package net.t2code.alias.Bungee.cmdManagement;

import net.md_5.bungee.api.CommandSender;
import net.md_5.bungee.api.chat.ClickEvent;
import net.md_5.bungee.api.connection.ProxiedPlayer;
import net.md_5.bungee.api.plugin.Command;
import net.t2code.alias.Bungee.Main;
import net.t2code.alias.Bungee.config.languages.SelectMessages;
import net.t2code.alias.Bungee.objects.AliasObjekt;
import net.t2code.lib.Bungee.Lib.commands.Bcmd;
import net.t2code.lib.Bungee.Lib.messages.Bsend;
import net.t2code.lib.Bungee.Lib.replace.BReplace;
import net.t2code.lib.Spigot.Lib.messages.TextBuilder;

public class RegisterCommands extends Command {
    private final String alias;
    private final String prefix = Main.prefix;

    public RegisterCommands(String alias) {
        super(alias);
        this.alias = alias;
    }

    @Override
    public void execute(CommandSender sender, String[] args) {
        AliasObjekt Alias = Main.aliasHashMap.get(alias);

        if (!Alias.aliasEnable) {
            Bsend.sender(sender, SelectMessages.aliasDisabled);
            return;
        }
        if (sender instanceof ProxiedPlayer) {
            ProxiedPlayer player = (ProxiedPlayer) sender;

            if (Alias.serverProtectionEnable) {
                if (Alias.serverProtectionMode.equalsIgnoreCase("blacklist") && Alias.serverProtectionList.contains(player.getServer().getInfo().getName())) {
                    return;
                }
                if (Alias.serverProtectionMode.equalsIgnoreCase("whitelist") && !Alias.serverProtectionList.contains(player.getServer().getInfo().getName())) {
                    return;
                }
            }

            if (Alias.adminEnable) {
                if (player.hasPermission(Alias.adminPermission)) {
                    if (Alias.adminCommandEnable) {
                        for (String cmd : Alias.adminCommands) {
                            if (Alias.adminCommandAsConsole) {
                                Bcmd.Console(cmd.replace("[player]", player.getName()));
                            } else {
                                Bcmd.Player(player, cmd.replace("[player]", player.getName()));
                            }
                        }
                    }
                    if (Alias.adminMessageEnable) {
                        for (String msg : Alias.adminMessages) {
                            String text = BReplace.replace(prefix, msg);
                            String hover = BReplace.replace(prefix, Alias.adminHover);
                            if (Alias.adminTextBuilder) {
                                TextBuilder textBuilder = new TextBuilder(text);
                                textBuilder.addHover(hover);
                                if (Alias.adminClickEvent) {
                                    textBuilder.addClickEvent(ClickEvent.Action.valueOf(Alias.adminAction), Alias.adminActionValue);
                                }
                                player.sendMessage(textBuilder.build());
                            } else {
                                Bsend.player(player, text);
                            }
                        }
                    }
                    return;
                }
            }
            if (Alias.permNecessary) {
                if (!(player.hasPermission("t2code.alias.use." + alias.toLowerCase()) || player.hasPermission("t2code.alias.admin"))) {
                    Bsend.player(player, SelectMessages.noPermissionForCommand.replace("[cmd]", "/" + alias.toLowerCase())
                            .replace("[perm]", "t2code.alias.use." + alias.toLowerCase()));
                    return;
                }
            }
            if (Alias.command_Enable) {
                for (String cmd : Alias.command) {
                    if (Alias.commandAsConsole) {
                        Bcmd.Console(cmd.replace("[player]", player.getName()));
                    } else {
                        Bcmd.Player(player, cmd.replace("[player]", player.getName()));
                    }
                }
            }
            if (Alias.messageEnable) {
                for (String msg : Alias.messages) {
                    String text = BReplace.replace(prefix, msg);
                    String hover = BReplace.replace(prefix, Alias.hover);
                    if (Alias.textBuilder) {
                        TextBuilder textBuilder = new TextBuilder(text);
                        textBuilder.addHover(hover);
                        if (Alias.clickEvent) {
                            textBuilder.addClickEvent(ClickEvent.Action.valueOf(Alias.action), Alias.actionValue);
                        }
                        player.sendMessage(textBuilder.build());
                    } else {
                        Bsend.player(player, text);
                    }
                }
            }
        } else {
            if (Alias.consoleEnable) {
                if (Alias.consoleCommandEnable) {
                    for (String cmd : Alias.consoleCommands) {
                        Bcmd.Console(cmd.replace("[player]", sender.getName()));
                    }
                }
                if (Alias.consoleMessageEnable) {
                    for (String msg : Alias.consoleMessages) {
                        Bsend.console(BReplace.replace(prefix, msg));
                    }
                }
            } else Bsend.sender(sender, SelectMessages.onlyForPlayer);
        }
        return;
    }
}

