package net.t2code.alias.Bungee.config.config;

import net.md_5.bungee.config.Configuration;
import net.md_5.bungee.config.ConfigurationProvider;
import net.md_5.bungee.config.YamlConfiguration;
import net.t2code.alias.Bungee.Main;
import net.t2code.lib.Bungee.Lib.messages.Bsend;
import net.t2code.lib.Bungee.Lib.yamlConfiguration.BConfig;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.List;

public class CreateExampleAliasConfig {

    private static Boolean Enable = true;
    private static Boolean PermNecessary = true;

    private static Boolean CommandEnable = false;
    private static Boolean CommandAsConsole = true;
    private static List Commands = Arrays.asList("end");

    private static Boolean MessageEnable = true;
    private static List Messages = Arrays.asList("&5Hi", "&6This is an example message");
    private static Boolean TextBuilder = true;
    private static String Hover = "&4T2Code";
    private static Boolean ClickEvent = true;
    private static String Action = "OPEN_URL";
    private static String ActionValue = "git.t2code.net";

    private static Boolean AdminEnable = false;
    private static String AdminPermission = "t2code.alias.admin";

    private static Boolean AdminCommandEnable = true;
    private static Boolean AdminCommandAsConsole = true;
    private static List AdminCommands = Arrays.asList();

    private static Boolean AdminMessageEnable = false;
    private static List AdminMessages = Arrays.asList();
    private static Boolean AdminTextBuilder = false;
    private static String AdminHover = "";
    private static Boolean AdminClickEvent = false;
    private static String AdminAction = "";
    private static String AdminActionValue = "";

    private static Boolean ConsoleEnable = false;
    private static Boolean ConsoleCommandEnable = false;
    private static List<String> ConsoleCommands = Arrays.asList();
    private static Boolean ConsoleMessageEnable = false;
    private static List<String> ConsoleMessages = Arrays.asList();

    public static void configCreate() throws IOException {
        Long long_ = Long.valueOf(System.currentTimeMillis());

        File directory = new File(Main.getPath(), "Alias");
        if (!directory.exists()) {
            directory.mkdir();
        }
        File config = new File(Main.getPath(), "Alias/aliasexample.yml");
        if (!config.exists()) {
            config.createNewFile();
        }

        Configuration configuration = ConfigurationProvider.getProvider(YamlConfiguration.class).load(config);


        BConfig.set("Alias.Enable", Enable, configuration);
        BConfig.set("Alias.Permission.Necessary", PermNecessary, configuration);

        BConfig.set("Alias.Protection.Server.Enable", false, configuration);
        BConfig.set("Alias.Protection.Server.Mode", "blacklist", configuration);
        BConfig.set("Alias.Protection.Server.List", Arrays.asList("Server1", "Server2"), configuration);

        BConfig.set("Alias.Command.Enable", CommandEnable, configuration);
        BConfig.set("Alias.Command.CommandAsConsole", CommandAsConsole, configuration);
        BConfig.set("Alias.Command.Commands", Commands, configuration);

        BConfig.set("Alias.Message.Enable", MessageEnable, configuration);
        BConfig.set("Alias.Message.Messages", Messages, configuration);
        BConfig.set("Alias.Message.TextBuilder.Enable", TextBuilder, configuration);
        BConfig.set("Alias.Message.TextBuilder.Hover", Hover, configuration);
        BConfig.set("Alias.Message.TextBuilder.ClickEvent.Enable", ClickEvent, configuration);
        BConfig.set("Alias.Message.TextBuilder.ClickEvent.Action", Action, configuration);
        BConfig.set("Alias.Message.TextBuilder.ClickEvent.ActionValue", ActionValue, configuration);

        BConfig.set("Alias.Admin.Enable", AdminEnable, configuration);
        BConfig.set("Alias.Admin.Permission", AdminPermission, configuration);

        BConfig.set("Alias.Admin.Command.Enable", AdminCommandEnable, configuration);
        BConfig.set("Alias.Admin.Command.CommandAsConsole", AdminCommandAsConsole, configuration);
        BConfig.set("Alias.Admin.Command.Commands", AdminCommands, configuration);

        BConfig.set("Alias.Admin.Message.Enable", AdminMessageEnable, configuration);
        BConfig.set("Alias.Admin.Message.Messages", AdminMessages, configuration);
        BConfig.set("Alias.Admin.Message.TextBuilder.Enable", AdminTextBuilder, configuration);
        BConfig.set("Alias.Admin.Message.TextBuilder.Hover", AdminHover, configuration);
        BConfig.set("Alias.Admin.Message.TextBuilder.ClickEvent.Enable", AdminClickEvent, configuration);
        BConfig.set("Alias.Admin.Message.TextBuilder.ClickEvent.Action", AdminAction, configuration);
        BConfig.set("Alias.Admin.Message.TextBuilder.ClickEvent.ActionValue", AdminActionValue, configuration);

        BConfig.set("Alias.Console.Enable", ConsoleEnable, configuration);
        BConfig.set("Alias.Console.Command.Enable", ConsoleCommandEnable, configuration);
        BConfig.set("Alias.Console.Command.Commands", ConsoleCommands, configuration);
        BConfig.set("Alias.Console.Message.Enable", ConsoleMessageEnable, configuration);
        BConfig.set("Alias.Console.Message.Messages", ConsoleMessages, configuration);
        ConfigurationProvider.getProvider(YamlConfiguration.class).save(configuration, config);
        Bsend.console(Main.prefix + " §2config.yml were successfully created / updated." + " §7- §e" + (System.currentTimeMillis() - long_.longValue()) + "ms");
    }
}
