package net.t2code.alias.Bungee.config.languages;

import net.md_5.bungee.api.plugin.Plugin;
import net.md_5.bungee.config.Configuration;
import net.md_5.bungee.config.ConfigurationProvider;
import net.md_5.bungee.config.YamlConfiguration;
import net.t2code.alias.Bungee.Main;
import net.t2code.lib.Bungee.Lib.messages.Bsend;
import net.t2code.lib.Bungee.Lib.yamlConfiguration.BConfig;

import java.io.File;
import java.io.IOException;

public class LanguagesCreate {
    private static Plugin plugin = Main.plugin;

    public static void langCreate() throws IOException {
        Bsend.debug(plugin, "§4Language files are created / updated...");
        Long long_ = Long.valueOf(System.currentTimeMillis());

        /**
         *
         * ENGLISH
         *
         */
        File directory = new File(Main.getPath(), "languages");
        if (!directory.exists()) {
            directory.mkdir();
        }
        File messagesEN = new File(Main.getPath(), "languages/english.yml");
        if (!messagesEN.exists()) {
            messagesEN.createNewFile();
        }
        Configuration configurationEN = ConfigurationProvider.getProvider(YamlConfiguration.class).load(messagesEN);

        BConfig.set("Plugin.OnlyForPlayer", MSG.EN_OnlyForPlayer, configurationEN);
        BConfig.set("Plugin.AliasDisabled", MSG.EN_Disabled, configurationEN);
        BConfig.set("Plugin.Reload.Start", MSG.EN_ReloadStart, configurationEN);
        BConfig.set("Plugin.Reload.End", MSG.EN_ReloadEnd, configurationEN);
        BConfig.set("Plugin.ForCommand", MSG.EN_NoPermissionForCommand, configurationEN);

        ConfigurationProvider.getProvider(YamlConfiguration.class).save(configurationEN, messagesEN);

        /**
         *
         * GERMAN
         *
         */

        File messagesDE = new File(Main.getPath(), "languages/german.yml");
        if (!messagesDE.exists()) {
            messagesDE.createNewFile();
        }
        Configuration configurationDE = ConfigurationProvider.getProvider(YamlConfiguration.class).load(messagesDE);

        BConfig.set("Plugin.OnlyForPlayer", MSG.DE_OnlyForPlayer, configurationDE);
        BConfig.set("Plugin.AliasDisabled", MSG.DE_Disabled, configurationDE);
        BConfig.set("Plugin.Reload.Start", MSG.DE_ReloadStart, configurationDE);
        BConfig.set("Plugin.Reload.End", MSG.DE_ReloadEnd, configurationDE);
        BConfig.set("Plugin.ForCommand", MSG.DE_NoPermissionForCommand, configurationDE);

        ConfigurationProvider.getProvider(YamlConfiguration.class).save(configurationEN, messagesDE);

        Bsend.console(Main.prefix + " §2Language files were successfully created / updated." + " §7- §e" + (System.currentTimeMillis() - long_.longValue()) + "ms");
    }
}
